# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from autoware_map_msgs/SignalLight.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class SignalLight(genpy.Message):
  _md5sum = "a38faee2ab9b5106b86c9785ffaff92d"
  _type = "autoware_map_msgs/SignalLight"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# This represents each lamps in signal light in a map.

# COLOR_TYPES
uint8 RED = 1
uint8 GREEN = 2
uint8 YELLOW = 3
uint8 RED_FLASHING = 4
uint8 GREEN_FLASHING = 5
uint8 YELLOW_FLASHING = 6
uint8 UNKOWN = 7

# ARROW_TYPES
uint8 NONE = 0
uint8 UP = 1
uint8 UP_RIGHT = 2
uint8 RIGHT = 3
uint8 DOWN_RIGHT = 4
uint8 DOWN = 5
uint8 DOWN_LEFT = 6
uint8 LEFT = 7
uint8 UP_LEFT = 8
uint8 UNKNOWN = 9

# Id of this SignalLight object. Must be uniqe among all SignalLight objects. 
int32 signal_light_id

# Id of Signal object which this SignalLight object belongs to
int32 signal_id

# Id of point that represents the position of this lamp. 
int32 point_id

# Horizontal direction which this SignalLight is facing in [deg].
# Angle is calculated from North in clockwise direction. 
float64 horizontal_angle

# Vertical direction which this SignalLight is facing in [deg].
# Angle is calculated from vertical rising direction. 
float64 vertical_angle

# Color of the lamp
# Must be one of COLOR_TYPES
int32 color_type

# Direction of the arrow (if the lamp has direction)
# Must be one of ARROW_TYPES
int32 arrow_type
"""
  # Pseudo-constants
  RED = 1
  GREEN = 2
  YELLOW = 3
  RED_FLASHING = 4
  GREEN_FLASHING = 5
  YELLOW_FLASHING = 6
  UNKOWN = 7
  NONE = 0
  UP = 1
  UP_RIGHT = 2
  RIGHT = 3
  DOWN_RIGHT = 4
  DOWN = 5
  DOWN_LEFT = 6
  LEFT = 7
  UP_LEFT = 8
  UNKNOWN = 9

  __slots__ = ['signal_light_id','signal_id','point_id','horizontal_angle','vertical_angle','color_type','arrow_type']
  _slot_types = ['int32','int32','int32','float64','float64','int32','int32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       signal_light_id,signal_id,point_id,horizontal_angle,vertical_angle,color_type,arrow_type

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SignalLight, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.signal_light_id is None:
        self.signal_light_id = 0
      if self.signal_id is None:
        self.signal_id = 0
      if self.point_id is None:
        self.point_id = 0
      if self.horizontal_angle is None:
        self.horizontal_angle = 0.
      if self.vertical_angle is None:
        self.vertical_angle = 0.
      if self.color_type is None:
        self.color_type = 0
      if self.arrow_type is None:
        self.arrow_type = 0
    else:
      self.signal_light_id = 0
      self.signal_id = 0
      self.point_id = 0
      self.horizontal_angle = 0.
      self.vertical_angle = 0.
      self.color_type = 0
      self.arrow_type = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3i2d2i().pack(_x.signal_light_id, _x.signal_id, _x.point_id, _x.horizontal_angle, _x.vertical_angle, _x.color_type, _x.arrow_type))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 36
      (_x.signal_light_id, _x.signal_id, _x.point_id, _x.horizontal_angle, _x.vertical_angle, _x.color_type, _x.arrow_type,) = _get_struct_3i2d2i().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3i2d2i().pack(_x.signal_light_id, _x.signal_id, _x.point_id, _x.horizontal_angle, _x.vertical_angle, _x.color_type, _x.arrow_type))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 36
      (_x.signal_light_id, _x.signal_id, _x.point_id, _x.horizontal_angle, _x.vertical_angle, _x.color_type, _x.arrow_type,) = _get_struct_3i2d2i().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3i2d2i = None
def _get_struct_3i2d2i():
    global _struct_3i2d2i
    if _struct_3i2d2i is None:
        _struct_3i2d2i = struct.Struct("<3i2d2i")
    return _struct_3i2d2i
