# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from autoware_map_msgs/Waypoint.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class Waypoint(genpy.Message):
  _md5sum = "6a92fbf1608fe14a2a517fbd332e0c6a"
  _type = "autoware_map_msgs/Waypoint"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# This represents a waypoint in a map. 

# Id of this Waypoint object
int32 waypoint_id

# Id of Point that represents the position of this waypoint
int32 point_id

# reference velocity of this waypoint. [km/h]
float64 velocity

# describes whether vehicle must stop at this waypoint
# no_stop = 0, stop = 1
int32 stop_line

# distance to left border of the belonging lane in [m]
float64 left_width

# distance to right border of the belonging lane in [m]
float64 right_width

# height limit for the vehicle to drive this waypoint [m]
float64 height
"""
  __slots__ = ['waypoint_id','point_id','velocity','stop_line','left_width','right_width','height']
  _slot_types = ['int32','int32','float64','int32','float64','float64','float64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       waypoint_id,point_id,velocity,stop_line,left_width,right_width,height

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Waypoint, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.waypoint_id is None:
        self.waypoint_id = 0
      if self.point_id is None:
        self.point_id = 0
      if self.velocity is None:
        self.velocity = 0.
      if self.stop_line is None:
        self.stop_line = 0
      if self.left_width is None:
        self.left_width = 0.
      if self.right_width is None:
        self.right_width = 0.
      if self.height is None:
        self.height = 0.
    else:
      self.waypoint_id = 0
      self.point_id = 0
      self.velocity = 0.
      self.stop_line = 0
      self.left_width = 0.
      self.right_width = 0.
      self.height = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2idi3d().pack(_x.waypoint_id, _x.point_id, _x.velocity, _x.stop_line, _x.left_width, _x.right_width, _x.height))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 44
      (_x.waypoint_id, _x.point_id, _x.velocity, _x.stop_line, _x.left_width, _x.right_width, _x.height,) = _get_struct_2idi3d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2idi3d().pack(_x.waypoint_id, _x.point_id, _x.velocity, _x.stop_line, _x.left_width, _x.right_width, _x.height))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 44
      (_x.waypoint_id, _x.point_id, _x.velocity, _x.stop_line, _x.left_width, _x.right_width, _x.height,) = _get_struct_2idi3d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2idi3d = None
def _get_struct_2idi3d():
    global _struct_2idi3d
    if _struct_2idi3d is None:
        _struct_2idi3d = struct.Struct("<2idi3d")
    return _struct_2idi3d
