# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from autoware_map_msgs/WaypointRelation.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class WaypointRelation(genpy.Message):
  _md5sum = "9c1af23db81a8c716746b8dc9e1511af"
  _type = "autoware_map_msgs/WaypointRelation"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# This represents the connection between a waypoint and a lane.

# Id of refering Waypoint object
int32 waypoint_id

# Id of Waypoint object that follows the refering waypoint
int32 next_waypoint_id

# Direction from the refering waypoint to next waypoint in [rad].
# The angle is calculated from North in counter clockwise. 
float64 yaw

# Blinker that vehicle must light up when driving from waypoint to next_waypoint
int32 blinker

# Distance between waypoint and next_waypoint
float64 distance
"""
  __slots__ = ['waypoint_id','next_waypoint_id','yaw','blinker','distance']
  _slot_types = ['int32','int32','float64','int32','float64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       waypoint_id,next_waypoint_id,yaw,blinker,distance

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(WaypointRelation, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.waypoint_id is None:
        self.waypoint_id = 0
      if self.next_waypoint_id is None:
        self.next_waypoint_id = 0
      if self.yaw is None:
        self.yaw = 0.
      if self.blinker is None:
        self.blinker = 0
      if self.distance is None:
        self.distance = 0.
    else:
      self.waypoint_id = 0
      self.next_waypoint_id = 0
      self.yaw = 0.
      self.blinker = 0
      self.distance = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2idid().pack(_x.waypoint_id, _x.next_waypoint_id, _x.yaw, _x.blinker, _x.distance))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 28
      (_x.waypoint_id, _x.next_waypoint_id, _x.yaw, _x.blinker, _x.distance,) = _get_struct_2idid().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2idid().pack(_x.waypoint_id, _x.next_waypoint_id, _x.yaw, _x.blinker, _x.distance))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 28
      (_x.waypoint_id, _x.next_waypoint_id, _x.yaw, _x.blinker, _x.distance,) = _get_struct_2idid().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2idid = None
def _get_struct_2idid():
    global _struct_2idid
    if _struct_2idid is None:
        _struct_2idid = struct.Struct("<2idid")
    return _struct_2idid
